var Locale = {
  langs: [],
  resources: {},

  setLanguages: function(langs, callback) {
    this.langs = [];
    this.langsToLoad = langs;
    this.callback = callback;
    this.resources = {};
    this.loadLang();
  },

  getResource: function(options) {
    if (this[options.type]) {
      return this[options.type](options);
    }
  },

  /**
   * shortcut for getResource with translate string option
   * s: string id or options as for getResource
   **/
  t: function(s) {
    //TODO: check is it object or string
    // if (s is object) return getResource($.extend({type: 'translate'}, s));
    return this.getResource({type: 'translate', id: s});
  },

  /********* private ***********/

  translate: function(options) {
    // TODO: options
    var r = null;
    var l = 0;
    while (!r && l < this.langs.length) {
      if (this.resources[this.langs[l]]) {
        if (this.resources[this.langs[l]]['text']) {
          r = this.resources[this.langs[l]]['text'][options.id];
        }
      }
      l++;
    }
    return r;
  },

  /******** private utils *******/

  loadLang: function() {
    var self = this;
    $.ajax({
      url: 'language/' + self.langsToLoad[0] + '.js',
      dataType: 'script',
      success: function(data, textStatus, jqXHR) {
        self.resources[self.langsToLoad[0]] = LangResource;
        self.langs.push(self.langsToLoad[0]);
        self.checkLangsLoadComplete();
      },
      fail: function() {
        self.checkLangsLoadComplete();
      }
    });
  },

  checkLangsLoadComplete: function() {
    this.langsToLoad.shift();
    if (0 < this.langsToLoad.length) {
      this.loadLang();
    } else {
      this.callback && this.callback.fn.call(this.callback.scope);
    }
  }
}
