function Account(proxy, version) {
  this.proxy = proxy;
  this.account = null;
  this.versionModel = version;
}

// public
// config {
//   update: boolean, get from server forced (default false)
//   sync: boolean (default false), N.B.: it locks the app
//   callback: {scope, fn}
//}
Account.prototype.get = function(config) {
  var c = $.extend({update: false, sync: false}, config);
  var versionUpdate = c.update;
  if (c.update) {
    c.update = false;
    this.account = null;
  }
  var account = this.account;
  var isAccountFull = (this.account && this.account.subscription && this.account.lastVersion && this.account.curVersion);
  if ((isAccountFull && !c.update) || c.prevLoadFailed) {
    c.callback && c.callback.fn.call(c.scope, this.account);
  } else {
    var self = this;
    this.proxy.getAccount({scope: self,
      fn: function(success, result) {
        self.onAccountLoaded(success, result);
        c.prevLoadFailed = !(success && result);
        this.versionModel.get({sync: c.sync, update: versionUpdate, callback: {scope: self,
          fn: function(version) {
            self.account = $.extend(self.account, version);
            c.prevLoadFailed = !(version && version.lastVersion && version.curVersion);
            account = self.get(c);
          }
        }});
      }
    }, {sync: c.sync});
  }

  return account;
}

// private callback
Account.prototype.onAccountLoaded = function(success, result) {
  if (success && result) {
    if (result.account) {
      this.account = this.account || {};
      this.account.subscription = result.account;
    }
  }
}


