function Queue(proxy) {
  this.proxy = proxy;
  this.films = [];
  this.perPage = 20;
}

// public
// config {
//   update: boolean, get from server forced (default false)
//   sync: boolean (default false), N.B.: it locks the app
//   callback: {scope, fn}
//   start: int, start index (default 0)
//   count: int (default perPage)
//}
Queue.prototype.get = function(config) {
  var c = $.extend({update: false, sync: false, start:0, count: this.perPage}, config);

  if (c.update) {
    this.films = [];
    this.totalCount = null;
    c.update = false;
    c.count = c.start + c.count;
    c.start = 0;
  }

  var f = this.getFilms(c.start, c.count, true);
  alert("Queue.get() " + objToString(f));
  if ((f.films && !f.hasGap) || c.prevLoadFailed || 0 == this.totalCount) {
    this.getQueueResult = f.films;
    c.callback && c.callback.fn.call(c.scope, this.getQueueResult);
  } else {
    var startIndex = (-1 == f.gapIndex) ? c.start : f.gapIndex;
    c.page = this.getPage(startIndex);
    var self = this;
    this.proxy.getQueue(c.page, {scope: self, 
      fn: function(success, result) {
        self.onQueueLoaded(c, success, result);
        c.prevLoadFailed = !(success && result);
        this.getQueueResult = self.get(c);
      }
    }, {sync: c.sync});
  }

  return this.getQueueResult;
}

// public
// config {
//   film,
//   callback: {scope, fn}
// }
Queue.prototype.removeFromQueue = function(config) {
  var self = this;
  var c = config;
  this.proxy.removeFilmFromQueue(c.film.queued_id, { scope: self,
    fn: function(success, result) {
      var successResult = result && result.data && result.data.hasOwnProperty('id');
      if (successResult) {
        success = true;
        for(var i = 0; i < self.films.length; i++) {
          if (result.data.id == self.films[i].queued_id) {
            self.films.splice(i, 1);
            this.totalCount--;
            break;
          }
        }
      }
      c.callback && c.callback.fn.call(c.callback.scope, successResult, self.films);
    }
  });
}

// private callback
Queue.prototype.onQueueLoaded = function(config, success, result) {
  if (success && result) {
    if (result.queue_items) {
      var f = result.queue_items;
      for (var j = 0, i = (config.page - 1) * this.perPage; j < f.length; j++, i++) {
        this.films[i] = f[j];
        this.films[i].title = f[j].main_title + (f[j].sub_title ? (' ' + f[j].sub_title) : '');
        this.films[i].streamUrls = this.films[i][AppInfo.streamUrlsPrefix() + "_urls"];
      }
    }
    if (result.pagination) {
      this.totalCount = result.pagination.total_entries;
      this.perPage = result.pagination.per_page;
    }
  }
}

// private
Queue.prototype.getPage = function(start) {
  return Math.floor(start/this.perPage) + 1;
}

// private
Queue.prototype.getFilms = function(start, count, breakOnGape) {
  var f = null;
  var hasGap = false;
  var gapIndex = -1;
  if (start < this.totalCount) {
    f = [];
    var endIndex = Math.min(start + count, this.totalCount);
    for (var i = start; i < endIndex; i++) {
      if (!this.films[i]) {
        gapIndex = i;
        hasGap = true;
        if (breakOnGape) {
          break;
        }
      }
      f.push(this.films[i]);
    }
  }
  return { films: f, hasGap: hasGap, gapIndex: gapIndex };
}

