var FlashPlayerCallback;
function FlashVideoPlayer(plugin) {
  alert("FlashFlashVideoPlayer.ctor() " + plugin);
  FlashPlayerCallback = this;
  this.plugin = plugin;
  this.FS = 1; //fullscreen;
  this.WM = 0; //window;

  this.STOPPED = 0;
  this.PLAYING = 1;
  this.PAUSED = 2;
}

///// actions with 'stream' /////

// public
FlashVideoPlayer.prototype.play = function(urlConfig) {
  if (urlConfig) {
    this.setUrl(urlConfig);
  }

  this.waitPlayerReady( function() {
    if (this.isState(this.PLAYING)) {
      this.stop();
    }
    if (this.isState(this.PAUSED)) {
      this.plugin.videoPause(true);
    } else {
      var c = this.urlConfig;
      this.plugin.setCredentials(c.session_id, c.user_id);
      this.plugin.setVideo({width: c.width, height: c.height, uri: c.streamUrls});

      if (c.continue && c.watched_percents) {
        this.urlConfig.continue = false;
        this.plugin.videoSeek(Math.floor(c.watched_percents * c.duration / 100));
      } else {
        this.plugin.videoPlay();
      }
    }
  }, urlConfig);
}

// public
FlashVideoPlayer.prototype.pause = function() {
  this.waitPlayerReady( function() {
    this.isState(this.PLAYING) && this.plugin.videoPause(true);
  });
}

// public
FlashVideoPlayer.prototype.togglePlay = function() {
  this.waitPlayerReady( function() {
    this.plugin.videoPause(true);
  });
}

// public
FlashVideoPlayer.prototype.stop = function() {
  this.waitPlayerReady( function() {
    this.plugin.videoStop();
  });
}

// public
//offset - seconds
FlashVideoPlayer.prototype.fw = function(offset, seekReadyCallback) {
  this.seek(offset, seekReadyCallback);
}

// public
FlashVideoPlayer.prototype.bw = function(offset, seekReadyCallback) {
  this.seek(-1 * offset, seekReadyCallback);
}

///// actions with screen //////////

// public
FlashVideoPlayer.prototype.setScreenMode = function(mode) {
  if (mode == this.FS) {
    $(this.plugin).css('left', '0px');
    fireEvent(this, Events.PLAYER_SCREEN_MODE_CHANGED, 1);
  } else {
    $(this.plugin).css('left', '960px');
    fireEvent(this, Events.PLAYER_SCREEN_MODE_CHANGED, 0);
  }
  this.screenMode = mode;
}

// public
FlashVideoPlayer.prototype.getScreenMode = function() {
  return this.screenMode;
}

// public
FlashVideoPlayer.prototype.toggleFS = function() {
}

// public
FlashVideoPlayer.prototype.setScreenModeRect = function(mode, rect) {
}

// public
FlashVideoPlayer.prototype.clearScreen = function() {

}

////////////////////////////////////////////////

// public
FlashVideoPlayer.prototype.setUrl = function(urlConfig) {
  this.urlConfig = urlConfig;
}

// public
FlashVideoPlayer.prototype.isState = function(state) {
  return state == this.state;
}

//////////////////////////////////////////////////////////////
FlashVideoPlayer.prototype.onBufferingStart = function() { fireEvent(this, Events.PLAYER_BUFFERING_START); }

FlashVideoPlayer.prototype.onBufferingProgress = function(percent) { fireEvent(this, Events.PLAYER_BUFFERING_PROGRESS, percent);  }

FlashVideoPlayer.prototype.onBufferingComplete = function() { fireEvent(this, Events.PLAYER_BUFFERING_COMPLETE); }

FlashVideoPlayer.prototype.onStreamInfoReady = function(duration) {
  this.isLive = (0 == duration);
  fireEvent(this, Events.PLAYER_STREAM_INFO_READY, {duration: duration * 1000, seekable: true, isLive: this.isLive});
}

FlashVideoPlayer.prototype.onRenderingComplete = function() {
  fireEvent(this, Events.PLAYER_COMPLETE);
}

FlashVideoPlayer.prototype.onPlayingStateChanged = function(state) {
  if (state != this.state) {
    this.state = state;
    if (this.PLAYING == this.state) {
      pluginAPI.setOffScreenSaver();
    } else {
      pluginAPI.setOnScreenSaver();
    }
    fireEvent(this, Events.PLAYER_STATE_CHANGED, this.state);
    this.updatePlayheadTimer(this.isState(this.PLAYING));
  }
}

/////////////////////////////////////////////////////////////

// private
FlashVideoPlayer.prototype.seek = function(offset, seekReadyCallback) {
    this.waitPlayerReady( function() {
    if (this.isLive) {
      var curTimestamp = this.plugin.getPlayheadTimestamp();
      var seekTimestamp = curTimestamp + offset * 1000;
      alert("@@@@ FlashVideoPlayer.seek() " + offset + " | " + curTimestamp + " | " + seekTimestamp);
      this.plugin.videoSeek2Timestamp(seekTimestamp);
    } else {
      var position = Math.max(this.plugin.getPlayheadTime() + offset, 5); // it has the strange bug then position less 5 seconds ('black screen' or endless buffering)
      this.plugin.videoSeek(position);
    }
    fireEvent(this, Events.PLAYER_SEEK);
    seekReadyCallback && seekReadyCallback.fn.call(seekReadyCallback.scope);
  });

}

// private
FlashVideoPlayer.prototype.updatePlayheadTimer = function(on) {
  clearInterval(this.playheadTimer);
  if (on) {
    var self = this;
    this.playheadTimer = setInterval( function() {
      var time = 0;
      var maxLiveTime = NaN;
      if (self.isLive) {
        time = self.plugin.getPlayheadTimestamp();
        maxLiveTime = self.plugin.getServerTimestamp();
        if (self.urlConfig.utc_offset) {
          var correction = self.urlConfig.utc_offset * 1000 + (new Date()).getTimezoneOffset() * 60 * 1000;
          time += correction;
          maxLiveTime += correction;
        }
      } else {
        time = self.plugin.getPlayheadTime() * 1000;
      }
      $(self).trigger(Events.PLAYER_CURRENT_TIME, [time, maxLiveTime]);
    }, 100);
  }
}

// private
FlashVideoPlayer.prototype.waitPlayerReady = function(fn, params) {
  if (window.flashPlayerInited) {
    try {
      fn.call(this, params);
    } catch (e) {
    }
  } else {
    var self = this;
    window.flashPlayerReadyCallbacks.push( {fn: fn, scope: self, params: params});
  }
}

