/**
 *  config: PagedDisplay config + { rowLength: Int }
 */
function ChannelsPagedDisplay(rootEl, config) {
  PagedDisplay.call(this, rootEl, config);
}

ChannelsPagedDisplay.inheritsFrom(PagedDisplay);

// public
ChannelsPagedDisplay.prototype.updatePage = function(config, abbr) {
  if (config) {
    this.updateConfig(config);
  }
  var items = this.getItems(this.curPage * this.pageSize, this.pageSize);
  if (0 == items.length && this.curPage != 0) {
    this.curPage--;
    items = this.getItems(this.curPage * this.pageSize, this.pageSize);
  }
  this.setupNavi(this.renderPage(items));
  var c = this.navi.getAllItems().filter(function(el) {return el && el.info.abbr == abbr;});
  var focusedEl = ( 0 < c.length ) ? c[0] : null;
  this.setCurEl(focusedEl);
}

// protected override
ChannelsPagedDisplay.prototype.renderPage = function(items) {
  var channels = [];
  for (var i = 0; i < items.length; i++) {
    var p = this.getPosByPageOffset(i);
    if (!channels[p.x]) {
      channels[p.x] = [];
    }
    items[i].channelId = 'channel' + i;
    channels[p.x][p.y] = {info: items[i], naviId: items[i].channelId};
  }

  var ch = new EJS({url: 'templates/channels.ejs'}).render({channels: items,
    emptyMessage: Locale.t('Channels.EmptyFav')});
  widgetAPI.putInnerHTML(this.rootEl, ch);
  return channels;
}

// protected override
ChannelsPagedDisplay.prototype.getPosByPageOffset = function(pageOffset) {
  var yy = Math.floor(pageOffset / this.rowLength);
  var xx = pageOffset - (this.rowLength * yy);
  return {x: xx, y: yy};
}

