function ProgressDisplay(config) {
  this.update(config);
}

ProgressDisplay.prototype.update = function(config) {
  $.extend(this, config);
}

ProgressDisplay.prototype.activate = function(config) {
  this.config = config;
  $(this.progressStatus).show();
  this.updateTime(0, 0);
}

ProgressDisplay.prototype.deactivate = function() {
  $(this.progressStatus).hide();
  this.updateTime(0, 0);
}

ProgressDisplay.prototype.updateTime = function(curTime, duration) {
  var c = timeToFormat(curTime, 'HH:mm:ss');
  var d = duration ? ('/' + timeToFormat(duration, ('HH:mm:ss'))): '';
  $(this.timeStatus).text(c + d);
  if (duration) {
    $(this.progressBar).css('width', Math.round(this.PROGRESS_BAR_WIDTH * curTime / duration));
    if (this.config.watched_percents) {
      $(this.watchedMark).css('left', Math.floor(this.PROGRESS_BAR_WIDTH * this.config.watched_percents / 100) + 'px');
      $(this.watchedMark).show();
    } else {
      $(this.watchedMark).hide();
    }
  }
}

