function ErrorScreen(config) {
  Screen.call(this, config);
  $(this).bind(Events.NAVI_SELECTION_SET
    , function(event, selectedButton) {
      selectedButton.callback.fn.call(selectedButton.callback.scope);
  });
}

ErrorScreen.inheritsFrom(Screen);

// protected override
ErrorScreen.prototype.fill = function(config) {
  var b = this.selectBehavior(config);

  var notification = new EJS({url: b.template}).render(b.info);
  widgetAPI.putInnerHTML(this.rootEl, notification);

  this.setupNaviWithLine(b.info.buttons, 'h', true);
  this.setCurEl();

  this.onFillComplete(config.focused);
}

// protected
ErrorScreen.prototype.selectBehavior = function(config) {
  var c = config || {};
  var self = this;
  var behavior =  {template: 'templates/notification.ejs',
    info: { buttons: [{label: Locale.t('Notification.Accept'), callback: {scope: self, fn: self.close}, naviId: 'NotificationScreen.btClose'}],
      message: '' }};
  behavior.info.message = this.getRequestErrorMessage(c.errorType);
  // TODO: select message by error description

  return behavior;
}

// protected
ErrorScreen.prototype.getRequestErrorMessage = function(errorType) {
  var message = Locale.t('RequestErrors.Unknown');
  switch (errorType) {
    case RequestErrors.TIMEOUT:
      message = Locale.t('RequestErrors.Timeout');
      break;
    case RequestErrors.INTERNAL_SERVER_ERROR:
      message = Locale.t('RequestErrors.InternalServerError');
      break;
    case RequestErrors.SERVICE_UNAVAILABLE:
      message = Locale.t('RequestErrors.ServiceUnavailable');
      break;
  }
  return message;
}

// protected
ErrorScreen.prototype.close = function() {
  this.hide();
}

