function FilmScreen(config) {
  Screen.call(this, config);
}

FilmScreen.inheritsFrom(Screen);

// public override
FilmScreen.prototype.getNaviButtons = function() {
  return this.naviButtons.concat({name: NavigationButtons.YELLOW, text: Locale.t('Film.Menu.RemoveFromQueue')});
}

FilmScreen.prototype.keyHandler = function(keyEvent) {
  switch(keyEvent.keyCode) {
    case tvKey.KEY_YELLOW:
      this.removeFromQueue();
      break;
    default:
      break;
  }
};

//////////////////////////////////////////////////////////////////

// protected override
FilmScreen.prototype.beforeHide= function() {
  //this.issuesPagedDisplay && this.issuesPagedDisplay.hide();
  // TODO: clear screenshot
}

// protected override
FilmScreen.prototype.fill = function(config) {
  this.film = config.film || this.film;
  alert("FilmScreen.fill() " + objToString(this.film));
  this.display(this.film);
  this.onFillComplete(config.focused);
}

//////////////////////////////////////////////////////////////////////

// private
FilmScreen.prototype.display = function(film) {
  var self = this;
  var html = new EJS({url: 'templates/film.ejs'}).render(film);
  widgetAPI.putInnerHTML(this.rootEl, html);

  this.menu = WidgetsFactory.filmScreen.getMenuNavi();
  $(this.menu).bind(Events.NAVI_SELECTION_SET,
    function(e, selectedItem) { self.onMenuSelectionChanged(selectedItem);
  });

  this.setupNaviWithLine([this.menu], 'h', true);

  this.setCurEl(this.menu, {saveCur: true});
};


// private (callback)
FilmScreen.prototype.onMenuSelectionChanged = function(selectedItem) {
   var f = getElLastName(selectedItem);
   this[f] && this[f]();
}

// private callback
FilmScreen.prototype.showBeginning = function() {
  this.film.continue = false;
  this.tryShowVideo(this.film);
}

// private callback
FilmScreen.prototype.showHistory = function() {
  this.film.continue = true;
  this.tryShowVideo(this.film);
}

// private callback
FilmScreen.prototype.removeFromQueue = function() {
  var self = this;
  ModelsFactory.getQueue().removeFromQueue({ film: this.film, callback: {scope: self, fn: self.onRemovedFromQueue}});
}

// private callback
FilmScreen.prototype.onRemovedFromQueue = function(success) {
  if (success) {
    this.return();
  }
}

// private callback
FilmScreen.prototype.onVideoComplete = function() {
  this.childScreen.return();
  this.return();
}

// private
FilmScreen.prototype.tryShowVideo = function(videoItem) {
  var hasAccess = videoItem.videostatus == 'full_access' && videoItem.streamUrls && videoItem.streamUrls[0];
  if (hasAccess) {
    var self = this;
    this.childScreen = WidgetsFactory.getPlayerScreen({parentScreen: this});
    this.childScreen.show({videoItem: videoItem, play: true,
      completeCallback: {fn: self.onVideoComplete, scope: self}
    });
  } else {
    WidgetsFactory.getNotificationScreen().show({message: Locale.t('Notification.VideoAccess')});
  }
}

