// TODO: использовать для Error
//
function NotificationScreen(config) {
  Screen.call(this, config);
  $(this).bind(Events.NAVI_SELECTION_SET
    , function(event, selectedButton) {
      selectedButton.callback.fn.call(selectedButton.callback.scope);
  });
}

NotificationScreen.inheritsFrom(Screen);

// public override
NotificationScreen.prototype.return = function() {
  this.callbackNeeds = true;
  Screen.prototype.return.call(this);
}

// protected override
NotificationScreen.prototype.beforeHide = function() {
  if (this.callbackNeeds) {
    this.returnCallback && this.returnCallback.fn.call(this.returnCallback.scope);
  }
  this.callbackNeeds = false;
}

// protected override
NotificationScreen.prototype.fill = function(config) {
  this.returnCallback = config.returnCallback;
  var self = this;
  var b = [{label: Locale.t('Notification.Accept'), callback: {scope: self, fn: self.close}, naviId: 'NotificationScreen.btClose'}];
  if (config.buttons) {
    b = [];
    for (var i = 0; i < config.buttons.length; i++) {
      b.push($.extend({naviId: 'NotificationScreen.bt' + i}, config.buttons[i]));
    }
  }

  var notification = new EJS({url: 'templates/notification.ejs'}).render({buttons: b, message: config.message});
  widgetAPI.putInnerHTML(this.rootEl, notification);

  this.setupNaviWithLine(b, 'h', true);
  this.setCurEl();

  this.onFillComplete(config.focused);
}

// protected
NotificationScreen.prototype.close = function() {
  this.hide();
}

